glibmm: Gio::MemoryInputStream Class Reference

glibmm 2.82.0

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::MemoryInputStream Class Reference
Stream Classes

MemoryInputStream implements InputStream for arbitrary memory chunks. More...

`#include <giomm/memoryinputstream.h>`

Inheritance diagram for Gio::MemoryInputStream:
[legend]

## Public Types
using | SlotDestroyData = sigc::slot< void(void *)>
| For example, void on_destroy_data(void* data);.
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| MemoryInputStream (MemoryInputStream &&src) noexcept
MemoryInputStream & | operator= (MemoryInputStream &&src) noexcept
| ~MemoryInputStream () noexcept override
GMemoryInputStream * | gobj ()
| Provides access to the underlying C GObject.
const GMemoryInputStream * | gobj () const
| Provides access to the underlying C GObject.
GMemoryInputStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | add_data (const void *data, gssize len, GDestroyNotify destroy)
| Appends data to data that can be read from the input stream.
void | add_data (const void *data, gssize len, const SlotDestroyData &destroy_slot)
| Appends to data that can be read from the input stream.
void | add_bytes (const Glib::RefPtr< const Glib::Bytes > & bytes)
| Appends bytes to data that can be read from the input stream.
Public Member Functions inherited from Gio::InputStream
| InputStream (InputStream &&src) noexcept
InputStream & | operator= (InputStream &&src) noexcept
| ~InputStream () noexcept override
GInputStream * | gobj ()
| Provides access to the underlying C GObject.
const GInputStream * | gobj () const
| Provides access to the underlying C GObject.
GInputStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
gssize | read (void *buffer, gsize count, const Glib::RefPtr< Cancellable > &cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer.
gssize | read (void *buffer, gsize count)
| A read() convenience overload.
bool | read_all (void *buffer, gsize count, gsize &bytes_read, const Glib::RefPtr< Cancellable > &cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer.
bool | read_all (void *buffer, gsize count, gsize &bytes_read)
| A read_all() convenience overload.
Glib::RefPtr< Glib::Bytes > | read_bytes (gsize count, const Glib::RefPtr< Cancellable > &cancellable)
| Like g_input_stream_read(), this tries to read count bytes from the stream in a blocking fashion.
void | read_bytes_async (gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into a new Glib::Bytes.
void | read_bytes_async (gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into a new Glib::Bytes.
Glib::RefPtr< Glib::Bytes > | read_bytes_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes an asynchronous stream read-into-Bytes operation.
gssize | skip (gsize count, const Glib::RefPtr< Cancellable > &cancellable)
| Tries to skip count bytes from the stream.
gssize | skip (gsize count)
| A skip() convenience overload.
bool | close (const Glib::RefPtr< Cancellable > &cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
| A close() convenience overload.
void | read_async (void *buffer, gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer.
void | read_async (void *buffer, gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer.
gssize | read_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes an asynchronous stream read operation.
void | read_all_async (void *buffer, gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer.
void | read_all_async (void *buffer, gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer.
bool | read_all_finish (const Glib::RefPtr< AsyncResult > &result, gsize &bytes_read)
| Finishes an asynchronous stream read operation started with g_input_stream_read_all_async().
void | skip_async (gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer.
void | skip_async (gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer.
gssize | skip_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes a stream skip operation.
void | close_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it.
void | close_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it.
gboolean | close_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes closing a stream asynchronously, started from g_input_stream_close_async().
bool | is_closed () const
| Checks if an input stream is closed.
bool | has_pending () const
| Checks if an input stream has pending actions.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data_with_c_callback (const Quark & key, void *data, GDestroyNotify notify)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::Seekable
| Seekable (Seekable &&src) noexcept
Seekable & | operator= (Seekable &&src) noexcept
| ~Seekable () noexcept override
GSeekable * | gobj ()
| Provides access to the underlying C GObject.
const GSeekable * | gobj () const
| Provides access to the underlying C GObject.
goffset | tell () const
| Tells the current position within the stream.
bool | can_seek () const
| Tests if the stream supports the SeekableIface.
bool | seek (goffset offset, Glib::SeekType type, const Glib::RefPtr< Cancellable > &cancellable)
| Seeks in the stream by the given offset, modified by type.
bool | seek (goffset offset, Glib::SeekType type)
| A seek() convenience overload.
bool | can_truncate () const
| Tests if the length of the stream can be adjusted with g_seekable_truncate().
bool | truncate (goffset offset, const Glib::RefPtr< Cancellable > &cancellable)
| Truncates a stream with a given offset.
bool | truncate (goffset offset)
| A truncate() convenience overload.
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor.
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Called by constructors of derived classes.
| Interface (GObject *castitem)
| Called by constructors of derived classes.
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gio::PollableInputStream
| PollableInputStream (PollableInputStream &&src) noexcept
PollableInputStream & | operator= (PollableInputStream &&src) noexcept
| ~PollableInputStream () noexcept override
GPollableInputStream * | gobj ()
| Provides access to the underlying C GObject.
const GPollableInputStream * | gobj () const
| Provides access to the underlying C GObject.
bool | can_poll () const
| Checks if stream is actually pollable.
bool | is_readable () const
| Checks if stream can be read.
gssize | read_nonblocking (void *buffer, gsize count, const Glib::RefPtr< Cancellable > &cancellable)
| Attempts to read up to count bytes from stream into buffer, as with g_input_stream_read().
gssize | read_nonblocking (void *buffer, gsize count)
| A read_nonblocking() convenience overload.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< MemoryInputStream > | create ()
Static Public Member Functions inherited from Gio::InputStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::Seekable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::PollableInputStream
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| MemoryInputStream ()
Protected Member Functions inherited from Gio::InputStream
| InputStream ()
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
virtual gssize | read_vfunc (void *buffer, gsize count, const Glib::RefPtr< Cancellable > &cancellable)
virtual gssize | skip_vfunc (gsize count, const Glib::RefPtr< Cancellable > &cancellable)
virtual bool | close_vfunc (const Glib::RefPtr< Cancellable > &cancellable)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char *custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info &custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gio::Seekable
| Seekable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gio::PollableInputStream
| PollableInputStream ()
| You should derive from this class to use it.
virtual bool | can_poll_vfunc () const
virtual bool | is_readable_vfunc () const
virtual gssize | read_nonblocking_vfunc (void *buffer, gsize count)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::MemoryInputStream > | wrap (GMemoryInputStream *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::InputStream
Glib::RefPtr< Gio::InputStream > | wrap (GInputStream *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Related Symbols inherited from Gio::Seekable
Glib::RefPtr< Gio::Seekable > | wrap (GSeekable *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::PollableInputStream
Glib::RefPtr< Gio::PollableInputStream > | wrap (GPollableInputStream *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

MemoryInputStream implements InputStream for arbitrary memory chunks.

Since glibmm 2.16:

## Member Typedef Documentation

## ◆ SlotDestroyData

using Gio::MemoryInputStream::SlotDestroyData = sigc::slot<void(void*)>

For example, void on_destroy_data(void* data);.

Parameters

  data | The data to free.

Since glibmm 2.40:

## Constructor & Destructor Documentation

## ◆ MemoryInputStream() [1/2]

Gio::MemoryInputStream::MemoryInputStream | ( | MemoryInputStream && | src | ) |
| noexcept

## ◆ ~MemoryInputStream()

Gio::MemoryInputStream::~MemoryInputStream | ( |  | ) |
| overridenoexcept

## ◆ MemoryInputStream() [2/2]

Gio::MemoryInputStream::MemoryInputStream | ( |  | ) |
| protected

## Member Function Documentation

## ◆ add_bytes()

void Gio::MemoryInputStream::add_bytes | ( | const Glib::RefPtr< const Glib::Bytes > & | bytes | ) |

Appends bytes to data that can be read from the input stream.

Since glibmm 2.44:

Parameters

  bytes | Input data.

## ◆ add_data() [1/2]

void Gio::MemoryInputStream::add_data | ( | const void * | data,
|  | gssize | len,
|  | const SlotDestroyData & | destroy_slot
| ) |  |

Appends to data that can be read from the input stream.

Parameters

  data | Input data.
  len | Length of the data, may be -1 if data is a null-terminated string.
  destroy_slot | A slot to be called to free the data when it is no longer needed.

Since glibmm 2.40:

## ◆ add_data() [2/2]

void Gio::MemoryInputStream::add_data | ( | const void * | data,
|  | gssize | len,
|  | GDestroyNotify | destroy
| ) |  |

Appends data to data that can be read from the input stream.

Parameters

  data | Input data.
  len | Length of the data, may be -1 if data is a nul-terminated string.
  destroy | Function that is called to free data, or `nullptr`.

## ◆ create()

static Glib::RefPtr< MemoryInputStream > Gio::MemoryInputStream::create | ( |  | ) |
| static

## ◆ get_type()

static GType Gio::MemoryInputStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GMemoryInputStream * Gio::MemoryInputStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GMemoryInputStream * Gio::MemoryInputStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GMemoryInputStream * Gio::MemoryInputStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

MemoryInputStream & Gio::MemoryInputStream::operator= | ( | MemoryInputStream && | src | ) |
| noexcept

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::MemoryInputStream > wrap | ( | GMemoryInputStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.